/* mdns.c generated by valac 0.39.7, the Vala compiler
 * generated from mdns.vala, do not modify */

/* vim: set tabstop=8 softtabstop=2 shiftwidth=2 expandtab: */
/*
 *    Copyright (C) 2011 Fabian Deutsch
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License along
 *    with this program; if not, write to the Free Software Foundation, Inc.,
 *    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <avahi-gobject/ga-entry-group.h>
#include <stdlib.h>
#include <string.h>
#include <avahi-gobject/ga-error.h>
#include <avahi-gobject/ga-client.h>
#include <avahi-gobject/ga-service-browser.h>
#include <avahi-gobject/ga-service-resolver.h>
#include <avahi-common/address.h>
#include <avahi-gobject/ga-enums.h>
#include <avahi-common/strlst.h>
#include <float.h>
#include <math.h>


#define MDNS_TYPE_MDNS_PROVIDER (mdns_mdns_provider_get_type ())
#define MDNS_MDNS_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MDNS_TYPE_MDNS_PROVIDER, MdnsMdnsProvider))
#define MDNS_MDNS_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MDNS_TYPE_MDNS_PROVIDER, MdnsMdnsProviderClass))
#define MDNS_IS_MDNS_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MDNS_TYPE_MDNS_PROVIDER))
#define MDNS_IS_MDNS_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MDNS_TYPE_MDNS_PROVIDER))
#define MDNS_MDNS_PROVIDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MDNS_TYPE_MDNS_PROVIDER, MdnsMdnsProviderClass))

typedef struct _MdnsMdnsProvider MdnsMdnsProvider;
typedef struct _MdnsMdnsProviderClass MdnsMdnsProviderClass;
typedef struct _MdnsMdnsProviderPrivate MdnsMdnsProviderPrivate;
enum  {
	MDNS_MDNS_PROVIDER_0_PROPERTY,
	MDNS_MDNS_PROVIDER_PORT_PROPERTY,
	MDNS_MDNS_PROVIDER_SERVICE_TYPE_PROPERTY,
	MDNS_MDNS_PROVIDER_TXT_PROPERTY,
	MDNS_MDNS_PROVIDER_IS_PUBLISHED_PROPERTY,
	MDNS_MDNS_PROVIDER_NAME_PROPERTY,
	MDNS_MDNS_PROVIDER_IS_IPV6_PROPERTY,
	MDNS_MDNS_PROVIDER_NUM_PROPERTIES
};
static GParamSpec* mdns_mdns_provider_properties[MDNS_MDNS_PROVIDER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	MDNS_MDNS_PROVIDER_SERVICE_DISCOVERED_SIGNAL,
	MDNS_MDNS_PROVIDER_SERVICE_LOST_SIGNAL,
	MDNS_MDNS_PROVIDER_NUM_SIGNALS
};
static guint mdns_mdns_provider_signals[MDNS_MDNS_PROVIDER_NUM_SIGNALS] = {0};

struct _MdnsMdnsProvider {
	GObject parent_instance;
	MdnsMdnsProviderPrivate * priv;
	GHashTable* available_services;
};

struct _MdnsMdnsProviderClass {
	GObjectClass parent_class;
};

struct _MdnsMdnsProviderPrivate {
	GaClient* client;
	GaEntryGroup* entry_group;
	GaEntryGroupService* published_service;
	GaServiceBrowser* service_browser;
	guint16 _port;
	gchar* _service_type;
	gchar* _txt;
	gboolean _is_published;
	gchar* _name;
	gboolean _is_ipv6;
	GaServiceResolver* service_resolver;
};


static gpointer mdns_mdns_provider_parent_class = NULL;

GaEntryGroupService* ga_entry_group_add_service (GaEntryGroup* group,
                                                 const gchar* name,
                                                 const gchar* type,
                                                 guint16 port,
                                                 GError** error,
                                                 ...);
GType mdns_mdns_provider_get_type (void) G_GNUC_CONST;
#define MDNS_MDNS_PROVIDER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), MDNS_TYPE_MDNS_PROVIDER, MdnsMdnsProviderPrivate))
MdnsMdnsProvider* mdns_mdns_provider_new (void);
MdnsMdnsProvider* mdns_mdns_provider_construct (GType object_type);
static void _g_free0_ (gpointer var);
static void mdns_mdns_provider_init_publish (MdnsMdnsProvider* self,
                                      GError** error);
static void mdns_mdns_provider_init_discovery (MdnsMdnsProvider* self,
                                        GError** error);
static void mdns_mdns_provider_connect_debuging_handlers (MdnsMdnsProvider* self);
static void mdns_mdns_provider_on_is_published_changed_cb (MdnsMdnsProvider* self);
static void _mdns_mdns_provider_on_is_published_changed_cb_g_object_notify (GObject* _sender,
                                                                     GParamSpec* pspec,
                                                                     gpointer self);
const gchar* mdns_mdns_provider_get_service_type (MdnsMdnsProvider* self);
static void mdns_mdns_provider_on_new_service_cb (MdnsMdnsProvider* self,
                                           AvahiIfIndex iface,
                                           AvahiProtocol proto,
                                           const gchar* name,
                                           const gchar* type,
                                           const gchar* domain,
                                           GaLookupResultFlags flags);
static void _mdns_mdns_provider_on_new_service_cb_ga_service_browser_new_service (GaServiceBrowser* _sender,
                                                                           AvahiIfIndex interface,
                                                                           AvahiProtocol protocol,
                                                                           const gchar* name,
                                                                           const gchar* type,
                                                                           const gchar* domain,
                                                                           GaLookupResultFlags flags,
                                                                           gpointer self);
static void mdns_mdns_provider_on_removed_service_cb (MdnsMdnsProvider* self,
                                               AvahiIfIndex iface,
                                               AvahiProtocol proto,
                                               const gchar* name,
                                               const gchar* type,
                                               const gchar* domain,
                                               GaLookupResultFlags flags);
static void _mdns_mdns_provider_on_removed_service_cb_ga_service_browser_removed_service (GaServiceBrowser* _sender,
                                                                                   AvahiIfIndex interface,
                                                                                   AvahiProtocol protocol,
                                                                                   const gchar* name,
                                                                                   const gchar* type,
                                                                                   const gchar* domain,
                                                                                   GaLookupResultFlags flags,
                                                                                   gpointer self);
static void __lambda4_ (MdnsMdnsProvider* self,
                 const gchar* name,
                 const gchar* uri,
                 const gchar* txt);
static void ___lambda4__mdns_mdns_provider_service_discovered (MdnsMdnsProvider* _sender,
                                                        const gchar* name,
                                                        const gchar* uri,
                                                        const gchar* txt,
                                                        gpointer self);
static void __lambda5_ (MdnsMdnsProvider* self,
                 const gchar* name);
static void ___lambda5__mdns_mdns_provider_service_lost (MdnsMdnsProvider* _sender,
                                                  const gchar* uri,
                                                  gpointer self);
static void mdns_mdns_provider_publish (MdnsMdnsProvider* self,
                                 GError** error);
const gchar* mdns_mdns_provider_get_name (MdnsMdnsProvider* self);
static void mdns_mdns_provider_unpublish (MdnsMdnsProvider* self,
                                   GError** error);
guint16 mdns_mdns_provider_get_port (MdnsMdnsProvider* self);
const gchar* mdns_mdns_provider_get_txt (MdnsMdnsProvider* self);
gboolean mdns_mdns_provider_get_is_published (MdnsMdnsProvider* self);
gboolean mdns_mdns_provider_get_is_ipv6 (MdnsMdnsProvider* self);
static void mdns_mdns_provider_on_service_found_cb (MdnsMdnsProvider* self,
                                             AvahiIfIndex iface,
                                             AvahiProtocol proto,
                                             const gchar* name,
                                             const gchar* type,
                                             const gchar* domain,
                                             const gchar* host,
                                             AvahiAddress* addr,
                                             guint16 port,
                                             AvahiStringList* txt,
                                             GaLookupResultFlags flags);
static void _mdns_mdns_provider_on_service_found_cb_ga_service_resolver_found (GaServiceResolver* _sender,
                                                                        AvahiIfIndex interface,
                                                                        AvahiProtocol protocol,
                                                                        const gchar* name,
                                                                        const gchar* type,
                                                                        const gchar* domain,
                                                                        const gchar* hostname,
                                                                        AvahiAddress* address,
                                                                        guint16 port,
                                                                        AvahiStringList* txt,
                                                                        GaLookupResultFlags flags,
                                                                        gpointer self);
void mdns_mdns_provider_set_port (MdnsMdnsProvider* self,
                                  guint16 value);
void mdns_mdns_provider_set_service_type (MdnsMdnsProvider* self,
                                          const gchar* value);
void mdns_mdns_provider_set_txt (MdnsMdnsProvider* self,
                                 const gchar* value);
void mdns_mdns_provider_set_is_published (MdnsMdnsProvider* self,
                                          gboolean value);
void mdns_mdns_provider_set_name (MdnsMdnsProvider* self,
                                  const gchar* value);
void mdns_mdns_provider_set_is_ipv6 (MdnsMdnsProvider* self,
                                     gboolean value);
static void g_cclosure_user_marshal_VOID__STRING_STRING_STRING (GClosure * closure,
                                                         GValue * return_value,
                                                         guint n_param_values,
                                                         const GValue * param_values,
                                                         gpointer invocation_hint,
                                                         gpointer marshal_data);
static void mdns_mdns_provider_finalize (GObject * obj);
static void _vala_mdns_mdns_provider_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_mdns_mdns_provider_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);


static void
_g_free0_ (gpointer var)
{
#line 88 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	var = (g_free (var), NULL);
#line 230 "mdns.c"
}


MdnsMdnsProvider*
mdns_mdns_provider_construct (GType object_type)
{
	MdnsMdnsProvider * self = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GaClient* _tmp3_;
	GError * _inner_error_ = NULL;
#line 86 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	self = (MdnsMdnsProvider*) g_object_new (object_type, NULL);
#line 88 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp0_ = g_str_hash;
#line 88 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp1_ = g_str_equal;
#line 88 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_free0_);
#line 88 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_g_hash_table_unref0 (self->available_services);
#line 88 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	self->available_services = _tmp2_;
#line 91 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp3_ = ga_client_new (GA_CLIENT_FLAG_NO_FLAGS);
#line 91 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_g_object_unref0 (self->priv->client);
#line 91 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	self->priv->client = _tmp3_;
#line 261 "mdns.c"
	{
		GaClient* _tmp4_;
#line 95 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		_tmp4_ = self->priv->client;
#line 95 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		ga_client_start (_tmp4_, &_inner_error_);
#line 95 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 270 "mdns.c"
			goto __catch0_g_error;
		}
#line 97 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		mdns_mdns_provider_init_publish (self, &_inner_error_);
#line 97 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 277 "mdns.c"
			goto __catch0_g_error;
		}
#line 98 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		mdns_mdns_provider_init_discovery (self, &_inner_error_);
#line 98 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 284 "mdns.c"
			goto __catch0_g_error;
		}
#line 100 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		mdns_mdns_provider_connect_debuging_handlers (self);
#line 289 "mdns.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp5_;
#line 93 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		e = _inner_error_;
#line 93 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		_inner_error_ = NULL;
#line 105 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		_tmp5_ = e->message;
#line 105 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		g_error ("mdns.vala:105: An error occured while setting up MDNS: %s", _tmp5_);
#line 93 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		_g_error_free0 (e);
#line 306 "mdns.c"
	}
	__finally0:
#line 93 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 93 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 93 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		g_clear_error (&_inner_error_);
#line 93 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		return NULL;
#line 317 "mdns.c"
	}
#line 86 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	return self;
#line 321 "mdns.c"
}


MdnsMdnsProvider*
mdns_mdns_provider_new (void)
{
#line 86 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	return mdns_mdns_provider_construct (MDNS_TYPE_MDNS_PROVIDER);
#line 330 "mdns.c"
}


static void
_mdns_mdns_provider_on_is_published_changed_cb_g_object_notify (GObject* _sender,
                                                                GParamSpec* pspec,
                                                                gpointer self)
{
#line 119 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	mdns_mdns_provider_on_is_published_changed_cb ((MdnsMdnsProvider*) self);
#line 341 "mdns.c"
}


static void
mdns_mdns_provider_init_publish (MdnsMdnsProvider* self,
                                 GError** error)
{
	GaEntryGroup* _tmp0_;
	GaEntryGroup* _tmp1_;
	GaClient* _tmp2_;
	GError * _inner_error_ = NULL;
#line 114 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_if_fail (self != NULL);
#line 116 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp0_ = ga_entry_group_new ();
#line 116 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_g_object_unref0 (self->priv->entry_group);
#line 116 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	self->priv->entry_group = _tmp0_;
#line 117 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp1_ = self->priv->entry_group;
#line 117 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp2_ = self->priv->client;
#line 117 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	ga_entry_group_attach (_tmp1_, _tmp2_, &_inner_error_);
#line 117 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 117 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		if (_inner_error_->domain == GA_ERROR) {
#line 117 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
			g_propagate_error (error, _inner_error_);
#line 117 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
			return;
#line 375 "mdns.c"
		} else {
#line 117 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 117 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
			g_clear_error (&_inner_error_);
#line 117 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
			return;
#line 383 "mdns.c"
		}
	}
#line 119 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_signal_connect_object ((GObject*) self, "notify::is-published", (GCallback) _mdns_mdns_provider_on_is_published_changed_cb_g_object_notify, self, 0);
#line 388 "mdns.c"
}


static void
_mdns_mdns_provider_on_new_service_cb_ga_service_browser_new_service (GaServiceBrowser* _sender,
                                                                      AvahiIfIndex interface,
                                                                      AvahiProtocol protocol,
                                                                      const gchar* name,
                                                                      const gchar* type,
                                                                      const gchar* domain,
                                                                      GaLookupResultFlags flags,
                                                                      gpointer self)
{
#line 126 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	mdns_mdns_provider_on_new_service_cb ((MdnsMdnsProvider*) self, interface, protocol, name, type, domain, flags);
#line 404 "mdns.c"
}


static void
_mdns_mdns_provider_on_removed_service_cb_ga_service_browser_removed_service (GaServiceBrowser* _sender,
                                                                              AvahiIfIndex interface,
                                                                              AvahiProtocol protocol,
                                                                              const gchar* name,
                                                                              const gchar* type,
                                                                              const gchar* domain,
                                                                              GaLookupResultFlags flags,
                                                                              gpointer self)
{
#line 127 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	mdns_mdns_provider_on_removed_service_cb ((MdnsMdnsProvider*) self, interface, protocol, name, type, domain, flags);
#line 420 "mdns.c"
}


static void
mdns_mdns_provider_init_discovery (MdnsMdnsProvider* self,
                                   GError** error)
{
	const gchar* _tmp0_;
	GaServiceBrowser* _tmp1_;
	GaServiceBrowser* _tmp2_;
	GaServiceBrowser* _tmp3_;
	GaServiceBrowser* _tmp4_;
	GaClient* _tmp5_;
	GError * _inner_error_ = NULL;
#line 122 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_if_fail (self != NULL);
#line 124 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp0_ = self->priv->_service_type;
#line 124 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp1_ = ga_service_browser_new (_tmp0_);
#line 124 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_g_object_unref0 (self->priv->service_browser);
#line 124 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	self->priv->service_browser = _tmp1_;
#line 126 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp2_ = self->priv->service_browser;
#line 126 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_signal_connect_object (_tmp2_, "new-service", (GCallback) _mdns_mdns_provider_on_new_service_cb_ga_service_browser_new_service, self, 0);
#line 127 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp3_ = self->priv->service_browser;
#line 127 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_signal_connect_object (_tmp3_, "removed-service", (GCallback) _mdns_mdns_provider_on_removed_service_cb_ga_service_browser_removed_service, self, 0);
#line 129 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp4_ = self->priv->service_browser;
#line 129 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp5_ = self->priv->client;
#line 129 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	ga_service_browser_attach (_tmp4_, _tmp5_, &_inner_error_);
#line 129 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 129 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		if (_inner_error_->domain == GA_ERROR) {
#line 129 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
			g_propagate_error (error, _inner_error_);
#line 129 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
			return;
#line 467 "mdns.c"
		} else {
#line 129 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 129 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
			g_clear_error (&_inner_error_);
#line 129 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
			return;
#line 475 "mdns.c"
		}
	}
}


static void
__lambda4_ (MdnsMdnsProvider* self,
            const gchar* name,
            const gchar* uri,
            const gchar* txt)
{
#line 134 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_if_fail (name != NULL);
#line 134 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_if_fail (uri != NULL);
#line 134 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_if_fail (txt != NULL);
#line 135 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_debug ("mdns.vala:135: Discovered %s (%s)\n%s", name, uri, txt);
#line 495 "mdns.c"
}


static void
___lambda4__mdns_mdns_provider_service_discovered (MdnsMdnsProvider* _sender,
                                                   const gchar* name,
                                                   const gchar* uri,
                                                   const gchar* txt,
                                                   gpointer self)
{
#line 134 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	__lambda4_ ((MdnsMdnsProvider*) self, name, uri, txt);
#line 508 "mdns.c"
}


static void
__lambda5_ (MdnsMdnsProvider* self,
            const gchar* name)
{
#line 137 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_if_fail (name != NULL);
#line 138 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_debug ("mdns.vala:138: Lost %s", name);
#line 520 "mdns.c"
}


static void
___lambda5__mdns_mdns_provider_service_lost (MdnsMdnsProvider* _sender,
                                             const gchar* uri,
                                             gpointer self)
{
#line 137 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	__lambda5_ ((MdnsMdnsProvider*) self, uri);
#line 531 "mdns.c"
}


static void
mdns_mdns_provider_connect_debuging_handlers (MdnsMdnsProvider* self)
{
#line 132 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_if_fail (self != NULL);
#line 134 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_signal_connect_object (self, "service-discovered", (GCallback) ___lambda4__mdns_mdns_provider_service_discovered, self, 0);
#line 137 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_signal_connect_object (self, "service-lost", (GCallback) ___lambda5__mdns_mdns_provider_service_lost, self, 0);
#line 544 "mdns.c"
}


static void
mdns_mdns_provider_publish (MdnsMdnsProvider* self,
                            GError** error)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GaEntryGroupService* _tmp2_;
	GaEntryGroupService* _tmp3_ = NULL;
	GaEntryGroup* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	guint16 _tmp7_;
	const gchar* _tmp8_;
	GaEntryGroupService* _tmp9_;
	GaEntryGroupService* _tmp10_;
	GaEntryGroup* _tmp11_;
	GError * _inner_error_ = NULL;
#line 142 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_if_fail (self != NULL);
#line 145 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp0_ = self->priv->_name;
#line 145 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp1_ = self->priv->_service_type;
#line 145 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_debug ("mdns.vala:145: Publishing '%s' as '%s'", _tmp0_, _tmp1_);
#line 147 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp2_ = self->priv->published_service;
#line 147 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	if (_tmp2_ != NULL) {
#line 149 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		mdns_mdns_provider_unpublish (self, &_inner_error_);
#line 149 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 149 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
			if (_inner_error_->domain == GA_ERROR) {
#line 149 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
				g_propagate_error (error, _inner_error_);
#line 149 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
				return;
#line 587 "mdns.c"
			} else {
#line 149 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 149 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
				g_clear_error (&_inner_error_);
#line 149 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
				return;
#line 595 "mdns.c"
			}
		}
	}
#line 152 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp4_ = self->priv->entry_group;
#line 152 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp5_ = self->priv->_name;
#line 152 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp6_ = self->priv->_service_type;
#line 152 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp7_ = self->priv->_port;
#line 152 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp8_ = self->priv->_txt;
#line 152 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp9_ = ga_entry_group_add_service (_tmp4_, _tmp5_, _tmp6_, _tmp7_, &_inner_error_, _tmp8_, NULL);
#line 152 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp3_ = _tmp9_;
#line 152 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 152 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		if (_inner_error_->domain == GA_ERROR) {
#line 152 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
			g_propagate_error (error, _inner_error_);
#line 152 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
			return;
#line 621 "mdns.c"
		} else {
#line 152 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 152 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
			g_clear_error (&_inner_error_);
#line 152 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
			return;
#line 629 "mdns.c"
		}
	}
#line 152 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp10_ = _tmp3_;
#line 152 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp3_ = NULL;
#line 152 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	self->priv->published_service = _tmp10_;
#line 158 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp11_ = self->priv->entry_group;
#line 158 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	ga_entry_group_commit (_tmp11_, &_inner_error_);
#line 158 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 158 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		if (_inner_error_->domain == GA_ERROR) {
#line 158 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
			g_propagate_error (error, _inner_error_);
#line 158 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
			return;
#line 650 "mdns.c"
		} else {
#line 158 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 158 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
			g_clear_error (&_inner_error_);
#line 158 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
			return;
#line 658 "mdns.c"
		}
	}
}


static void
mdns_mdns_provider_unpublish (MdnsMdnsProvider* self,
                              GError** error)
{
	GaEntryGroup* _tmp0_;
	GError * _inner_error_ = NULL;
#line 161 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_if_fail (self != NULL);
#line 163 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp0_ = self->priv->entry_group;
#line 163 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	ga_entry_group_reset (_tmp0_, &_inner_error_);
#line 163 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 163 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		if (_inner_error_->domain == GA_ERROR) {
#line 163 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
			g_propagate_error (error, _inner_error_);
#line 163 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
			return;
#line 684 "mdns.c"
		} else {
#line 163 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 163 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
			g_clear_error (&_inner_error_);
#line 163 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
			return;
#line 692 "mdns.c"
		}
	}
}


static void
mdns_mdns_provider_on_is_published_changed_cb (MdnsMdnsProvider* self)
{
	GError * _inner_error_ = NULL;
#line 169 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_if_fail (self != NULL);
#line 704 "mdns.c"
	{
		gboolean _tmp0_;
#line 173 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		_tmp0_ = self->priv->_is_published;
#line 173 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		if (_tmp0_) {
#line 175 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
			mdns_mdns_provider_publish (self, &_inner_error_);
#line 175 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 715 "mdns.c"
				goto __catch1_g_error;
			}
		} else {
#line 179 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
			mdns_mdns_provider_unpublish (self, &_inner_error_);
#line 179 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 723 "mdns.c"
				goto __catch1_g_error;
			}
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp1_;
#line 171 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		e = _inner_error_;
#line 171 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		_inner_error_ = NULL;
#line 184 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		_tmp1_ = e->message;
#line 184 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		g_error ("mdns.vala:184: An error occured while toggling publishing: %s", _tmp1_);
#line 171 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		_g_error_free0 (e);
#line 743 "mdns.c"
	}
	__finally1:
#line 171 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 171 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 171 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		g_clear_error (&_inner_error_);
#line 171 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		return;
#line 754 "mdns.c"
	}
}


static void
_mdns_mdns_provider_on_service_found_cb_ga_service_resolver_found (GaServiceResolver* _sender,
                                                                   AvahiIfIndex interface,
                                                                   AvahiProtocol protocol,
                                                                   const gchar* name,
                                                                   const gchar* type,
                                                                   const gchar* domain,
                                                                   const gchar* hostname,
                                                                   AvahiAddress* address,
                                                                   guint16 port,
                                                                   AvahiStringList* txt,
                                                                   GaLookupResultFlags flags,
                                                                   gpointer self)
{
#line 203 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	mdns_mdns_provider_on_service_found_cb ((MdnsMdnsProvider*) self, interface, protocol, name, type, domain, hostname, address, port, txt, flags);
#line 775 "mdns.c"
}


static void
mdns_mdns_provider_on_new_service_cb (MdnsMdnsProvider* self,
                                      AvahiIfIndex iface,
                                      AvahiProtocol proto,
                                      const gchar* name,
                                      const gchar* type,
                                      const gchar* domain,
                                      GaLookupResultFlags flags)
{
	AvahiProtocol _tmp0_ = 0;
	gboolean _tmp1_;
	AvahiProtocol req_proto = 0;
	GaServiceResolver* _tmp2_;
	GaServiceResolver* _tmp3_;
	GError * _inner_error_ = NULL;
#line 188 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_if_fail (self != NULL);
#line 188 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_if_fail (name != NULL);
#line 188 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_if_fail (type != NULL);
#line 188 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_if_fail (domain != NULL);
#line 196 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_debug ("mdns.vala:196: New service found: %s", name);
#line 198 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp1_ = self->priv->_is_ipv6;
#line 198 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	if (_tmp1_) {
#line 198 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		_tmp0_ = AVAHI_PROTO_INET6;
#line 810 "mdns.c"
	} else {
#line 198 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		_tmp0_ = AVAHI_PROTO_INET;
#line 814 "mdns.c"
	}
#line 198 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	req_proto = _tmp0_;
#line 200 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp2_ = ga_service_resolver_new (iface, proto, name, type, domain, req_proto, GA_LOOKUP_NO_FLAGS);
#line 200 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_g_object_unref0 (self->priv->service_resolver);
#line 200 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	self->priv->service_resolver = _tmp2_;
#line 203 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp3_ = self->priv->service_resolver;
#line 203 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_signal_connect_object (_tmp3_, "found", (GCallback) _mdns_mdns_provider_on_service_found_cb_ga_service_resolver_found, self, 0);
#line 828 "mdns.c"
	{
		GaServiceResolver* _tmp4_;
		GaClient* _tmp5_;
#line 207 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		_tmp4_ = self->priv->service_resolver;
#line 207 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		_tmp5_ = self->priv->client;
#line 207 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		ga_service_resolver_attach (_tmp4_, _tmp5_, &_inner_error_);
#line 207 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 840 "mdns.c"
			goto __catch2_g_error;
		}
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp6_;
#line 205 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		e = _inner_error_;
#line 205 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		_inner_error_ = NULL;
#line 211 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		_tmp6_ = e->message;
#line 211 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		g_error ("mdns.vala:211: Could not attach resolver: %s", _tmp6_);
#line 205 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		_g_error_free0 (e);
#line 859 "mdns.c"
	}
	__finally2:
#line 205 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 205 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 205 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		g_clear_error (&_inner_error_);
#line 205 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		return;
#line 870 "mdns.c"
	}
}


static void
mdns_mdns_provider_on_removed_service_cb (MdnsMdnsProvider* self,
                                          AvahiIfIndex iface,
                                          AvahiProtocol proto,
                                          const gchar* name,
                                          const gchar* type,
                                          const gchar* domain,
                                          GaLookupResultFlags flags)
{
	GHashTable* _tmp0_;
#line 215 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_if_fail (self != NULL);
#line 215 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_if_fail (name != NULL);
#line 215 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_if_fail (type != NULL);
#line 215 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_if_fail (domain != NULL);
#line 222 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp0_ = self->available_services;
#line 222 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	if (g_hash_table_remove (_tmp0_, name)) {
#line 225 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		g_debug ("mdns.vala:225: Previously known servicess lost: %s", name);
#line 227 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		g_signal_emit (self, mdns_mdns_provider_signals[MDNS_MDNS_PROVIDER_SERVICE_LOST_SIGNAL], 0, name);
#line 901 "mdns.c"
	}
}


static void
mdns_mdns_provider_on_service_found_cb (MdnsMdnsProvider* self,
                                        AvahiIfIndex iface,
                                        AvahiProtocol proto,
                                        const gchar* name,
                                        const gchar* type,
                                        const gchar* domain,
                                        const gchar* host,
                                        AvahiAddress* addr,
                                        guint16 port,
                                        AvahiStringList* txt,
                                        GaLookupResultFlags flags)
{
	gchar* uri = NULL;
	gsize _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gint _tmp2__length1;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gint _tmp4__length1;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean _tmp7_;
	GHashTable* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
#line 231 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_if_fail (self != NULL);
#line 231 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_if_fail (name != NULL);
#line 231 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_if_fail (type != NULL);
#line 231 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_if_fail (domain != NULL);
#line 231 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_if_fail (host != NULL);
#line 244 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp0_ = AVAHI_ADDRESS_STR_MAX;
#line 244 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp1_ = g_new0 (gchar, _tmp0_);
#line 244 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp2_ = _tmp1_;
#line 244 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp2__length1 = _tmp0_;
#line 244 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp3_ = avahi_address_snprint (_tmp2_, _tmp0_, addr);
#line 244 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp4_ = txt->text;
#line 244 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp4__length1 = txt->size;
#line 244 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp5_ = g_strdup_printf ("rtsp://%s:%g/%s", _tmp3_, (gdouble) port, (const gchar*) _tmp4_);
#line 244 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp6_ = _tmp5_;
#line 244 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp2_ = (g_free (_tmp2_), NULL);
#line 244 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	uri = _tmp6_;
#line 246 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp7_ = self->priv->_is_ipv6;
#line 246 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	if (_tmp7_) {
#line 973 "mdns.c"
		gsize _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gint _tmp10__length1;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gint _tmp12__length1;
		gchar* _tmp13_;
#line 248 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		_tmp8_ = AVAHI_ADDRESS_STR_MAX;
#line 248 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		_tmp9_ = g_new0 (gchar, _tmp8_);
#line 248 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		_tmp10_ = _tmp9_;
#line 248 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		_tmp10__length1 = _tmp0_;
#line 248 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		_tmp11_ = avahi_address_snprint (_tmp10_, _tmp0_, addr);
#line 248 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		_tmp12_ = txt->text;
#line 248 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		_tmp12__length1 = txt->size;
#line 248 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		_tmp13_ = g_strdup_printf ("rtsp://[%s]:%g/%s", _tmp11_, (gdouble) port, (const gchar*) _tmp12_);
#line 248 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		_g_free0 (uri);
#line 248 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		uri = _tmp13_;
#line 248 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		_tmp10_ = (g_free (_tmp10_), NULL);
#line 1004 "mdns.c"
	}
#line 252 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp14_ = self->available_services;
#line 252 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp15_ = g_strdup (name);
#line 252 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp16_ = uri;
#line 252 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp17_ = g_strdup (_tmp16_);
#line 252 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_hash_table_insert (_tmp14_, _tmp15_, _tmp17_);
#line 254 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp18_ = uri;
#line 254 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp19_ = avahi_string_list_to_string (txt);
#line 254 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp20_ = _tmp19_;
#line 254 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_signal_emit (self, mdns_mdns_provider_signals[MDNS_MDNS_PROVIDER_SERVICE_DISCOVERED_SIGNAL], 0, name, _tmp18_, _tmp20_);
#line 254 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_g_free0 (_tmp20_);
#line 231 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_g_free0 (uri);
#line 1028 "mdns.c"
}


guint16
mdns_mdns_provider_get_port (MdnsMdnsProvider* self)
{
	guint16 result;
	guint16 _tmp0_;
#line 42 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 42 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp0_ = self->priv->_port;
#line 42 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	result = _tmp0_;
#line 42 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	return result;
#line 1045 "mdns.c"
}


void
mdns_mdns_provider_set_port (MdnsMdnsProvider* self,
                             guint16 value)
{
#line 43 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_if_fail (self != NULL);
#line 43 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	if (mdns_mdns_provider_get_port (self) != value) {
#line 43 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		self->priv->_port = value;
#line 43 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		g_object_notify_by_pspec ((GObject *) self, mdns_mdns_provider_properties[MDNS_MDNS_PROVIDER_PORT_PROPERTY]);
#line 1061 "mdns.c"
	}
}


const gchar*
mdns_mdns_provider_get_service_type (MdnsMdnsProvider* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 48 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp0_ = self->priv->_service_type;
#line 48 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	result = _tmp0_;
#line 48 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	return result;
#line 1079 "mdns.c"
}


void
mdns_mdns_provider_set_service_type (MdnsMdnsProvider* self,
                                     const gchar* value)
{
#line 49 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_if_fail (self != NULL);
#line 49 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	if (g_strcmp0 (value, mdns_mdns_provider_get_service_type (self)) != 0) {
#line 1091 "mdns.c"
		gchar* _tmp0_;
#line 49 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		_tmp0_ = g_strdup (value);
#line 49 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		_g_free0 (self->priv->_service_type);
#line 49 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		self->priv->_service_type = _tmp0_;
#line 49 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		g_object_notify_by_pspec ((GObject *) self, mdns_mdns_provider_properties[MDNS_MDNS_PROVIDER_SERVICE_TYPE_PROPERTY]);
#line 1101 "mdns.c"
	}
}


const gchar*
mdns_mdns_provider_get_txt (MdnsMdnsProvider* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 54 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 54 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp0_ = self->priv->_txt;
#line 54 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	result = _tmp0_;
#line 54 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	return result;
#line 1119 "mdns.c"
}


void
mdns_mdns_provider_set_txt (MdnsMdnsProvider* self,
                            const gchar* value)
{
#line 55 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_if_fail (self != NULL);
#line 55 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	if (g_strcmp0 (value, mdns_mdns_provider_get_txt (self)) != 0) {
#line 1131 "mdns.c"
		gchar* _tmp0_;
#line 55 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		_tmp0_ = g_strdup (value);
#line 55 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		_g_free0 (self->priv->_txt);
#line 55 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		self->priv->_txt = _tmp0_;
#line 55 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		g_object_notify_by_pspec ((GObject *) self, mdns_mdns_provider_properties[MDNS_MDNS_PROVIDER_TXT_PROPERTY]);
#line 1141 "mdns.c"
	}
}


gboolean
mdns_mdns_provider_get_is_published (MdnsMdnsProvider* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 60 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 60 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp0_ = self->priv->_is_published;
#line 60 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	result = _tmp0_;
#line 60 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	return result;
#line 1159 "mdns.c"
}


void
mdns_mdns_provider_set_is_published (MdnsMdnsProvider* self,
                                     gboolean value)
{
#line 61 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_if_fail (self != NULL);
#line 61 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	if (mdns_mdns_provider_get_is_published (self) != value) {
#line 61 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		self->priv->_is_published = value;
#line 61 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		g_object_notify_by_pspec ((GObject *) self, mdns_mdns_provider_properties[MDNS_MDNS_PROVIDER_IS_PUBLISHED_PROPERTY]);
#line 1175 "mdns.c"
	}
}


const gchar*
mdns_mdns_provider_get_name (MdnsMdnsProvider* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 66 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 66 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp0_ = self->priv->_name;
#line 66 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	result = _tmp0_;
#line 66 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	return result;
#line 1193 "mdns.c"
}


void
mdns_mdns_provider_set_name (MdnsMdnsProvider* self,
                             const gchar* value)
{
#line 67 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_if_fail (self != NULL);
#line 67 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	if (g_strcmp0 (value, mdns_mdns_provider_get_name (self)) != 0) {
#line 1205 "mdns.c"
		gchar* _tmp0_;
#line 67 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		_tmp0_ = g_strdup (value);
#line 67 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		_g_free0 (self->priv->_name);
#line 67 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		self->priv->_name = _tmp0_;
#line 67 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		g_object_notify_by_pspec ((GObject *) self, mdns_mdns_provider_properties[MDNS_MDNS_PROVIDER_NAME_PROPERTY]);
#line 1215 "mdns.c"
	}
}


gboolean
mdns_mdns_provider_get_is_ipv6 (MdnsMdnsProvider* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 72 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 72 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp0_ = self->priv->_is_ipv6;
#line 72 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	result = _tmp0_;
#line 72 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	return result;
#line 1233 "mdns.c"
}


void
mdns_mdns_provider_set_is_ipv6 (MdnsMdnsProvider* self,
                                gboolean value)
{
#line 73 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_if_fail (self != NULL);
#line 73 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	if (mdns_mdns_provider_get_is_ipv6 (self) != value) {
#line 73 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		self->priv->_is_ipv6 = value;
#line 73 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		g_object_notify_by_pspec ((GObject *) self, mdns_mdns_provider_properties[MDNS_MDNS_PROVIDER_IS_IPV6_PROPERTY]);
#line 1249 "mdns.c"
	}
}


static void
g_cclosure_user_marshal_VOID__STRING_STRING_STRING (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_STRING_STRING) (gpointer data1, const char* arg_1, const char* arg_2, const char* arg_3, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_return_if_fail (n_param_values == 4);
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		data1 = closure->data;
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		data2 = param_values->data[0].v_pointer;
#line 1276 "mdns.c"
	} else {
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		data1 = param_values->data[0].v_pointer;
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		data2 = closure->data;
#line 1282 "mdns.c"
	}
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	callback = (GMarshalFunc_VOID__STRING_STRING_STRING) (marshal_data ? marshal_data : cc->callback);
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), g_value_get_string (param_values + 3), data2);
#line 1288 "mdns.c"
}


static void
mdns_mdns_provider_class_init (MdnsMdnsProviderClass * klass)
{
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	mdns_mdns_provider_parent_class = g_type_class_peek_parent (klass);
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_type_class_add_private (klass, sizeof (MdnsMdnsProviderPrivate));
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_mdns_mdns_provider_get_property;
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_mdns_mdns_provider_set_property;
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	G_OBJECT_CLASS (klass)->finalize = mdns_mdns_provider_finalize;
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MDNS_MDNS_PROVIDER_PORT_PROPERTY, mdns_mdns_provider_properties[MDNS_MDNS_PROVIDER_PORT_PROPERTY] = g_param_spec_uint ("port", "port", "port", 0, G_MAXUINT, (guint16) 8554, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MDNS_MDNS_PROVIDER_SERVICE_TYPE_PROPERTY, mdns_mdns_provider_properties[MDNS_MDNS_PROVIDER_SERVICE_TYPE_PROPERTY] = g_param_spec_string ("service-type", "service-type", "service-type", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MDNS_MDNS_PROVIDER_TXT_PROPERTY, mdns_mdns_provider_properties[MDNS_MDNS_PROVIDER_TXT_PROPERTY] = g_param_spec_string ("txt", "txt", "txt", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MDNS_MDNS_PROVIDER_IS_PUBLISHED_PROPERTY, mdns_mdns_provider_properties[MDNS_MDNS_PROVIDER_IS_PUBLISHED_PROPERTY] = g_param_spec_boolean ("is-published", "is-published", "is-published", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MDNS_MDNS_PROVIDER_NAME_PROPERTY, mdns_mdns_provider_properties[MDNS_MDNS_PROVIDER_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MDNS_MDNS_PROVIDER_IS_IPV6_PROPERTY, mdns_mdns_provider_properties[MDNS_MDNS_PROVIDER_IS_IPV6_PROPERTY] = g_param_spec_boolean ("is-ipv6", "is-ipv6", "is-ipv6", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	mdns_mdns_provider_signals[MDNS_MDNS_PROVIDER_SERVICE_DISCOVERED_SIGNAL] = g_signal_new ("service-discovered", MDNS_TYPE_MDNS_PROVIDER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING_STRING, G_TYPE_NONE, 3, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING);
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	mdns_mdns_provider_signals[MDNS_MDNS_PROVIDER_SERVICE_LOST_SIGNAL] = g_signal_new ("service-lost", MDNS_TYPE_MDNS_PROVIDER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 1321 "mdns.c"
}


static void
mdns_mdns_provider_instance_init (MdnsMdnsProvider * self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	self->priv = MDNS_MDNS_PROVIDER_GET_PRIVATE (self);
#line 41 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	self->priv->_port = (guint16) 8554;
#line 47 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp0_ = g_strdup ("_rtsp._tcp");
#line 47 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	self->priv->_service_type = _tmp0_;
#line 53 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp1_ = g_strdup ("presence");
#line 53 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	self->priv->_txt = _tmp1_;
#line 59 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	self->priv->_is_published = FALSE;
#line 65 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_tmp2_ = g_strdup ("no-name-yet");
#line 65 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	self->priv->_name = _tmp2_;
#line 71 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	self->priv->_is_ipv6 = FALSE;
#line 1351 "mdns.c"
}


static void
mdns_mdns_provider_finalize (GObject * obj)
{
	MdnsMdnsProvider * self;
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MDNS_TYPE_MDNS_PROVIDER, MdnsMdnsProvider);
#line 111 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_g_object_unref0 (self->priv->service_resolver);
#line 111 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	self->priv->service_resolver = NULL;
#line 33 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_g_object_unref0 (self->priv->client);
#line 35 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_g_object_unref0 (self->priv->entry_group);
#line 37 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_g_object_unref0 (self->priv->service_browser);
#line 39 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_g_hash_table_unref0 (self->available_services);
#line 47 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_g_free0 (self->priv->_service_type);
#line 53 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_g_free0 (self->priv->_txt);
#line 65 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_g_free0 (self->priv->_name);
#line 84 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	_g_object_unref0 (self->priv->service_resolver);
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	G_OBJECT_CLASS (mdns_mdns_provider_parent_class)->finalize (obj);
#line 1383 "mdns.c"
}


/**
   * Handles MDNS based publishing and discovery.
   */
GType
mdns_mdns_provider_get_type (void)
{
	static volatile gsize mdns_mdns_provider_type_id__volatile = 0;
	if (g_once_init_enter (&mdns_mdns_provider_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MdnsMdnsProviderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mdns_mdns_provider_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MdnsMdnsProvider), 0, (GInstanceInitFunc) mdns_mdns_provider_instance_init, NULL };
		GType mdns_mdns_provider_type_id;
		mdns_mdns_provider_type_id = g_type_register_static (G_TYPE_OBJECT, "MdnsMdnsProvider", &g_define_type_info, 0);
		g_once_init_leave (&mdns_mdns_provider_type_id__volatile, mdns_mdns_provider_type_id);
	}
	return mdns_mdns_provider_type_id__volatile;
}


static void
_vala_mdns_mdns_provider_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	MdnsMdnsProvider * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MDNS_TYPE_MDNS_PROVIDER, MdnsMdnsProvider);
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	switch (property_id) {
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		case MDNS_MDNS_PROVIDER_PORT_PROPERTY:
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		g_value_set_uint (value, mdns_mdns_provider_get_port (self));
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		break;
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		case MDNS_MDNS_PROVIDER_SERVICE_TYPE_PROPERTY:
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		g_value_set_string (value, mdns_mdns_provider_get_service_type (self));
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		break;
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		case MDNS_MDNS_PROVIDER_TXT_PROPERTY:
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		g_value_set_string (value, mdns_mdns_provider_get_txt (self));
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		break;
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		case MDNS_MDNS_PROVIDER_IS_PUBLISHED_PROPERTY:
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		g_value_set_boolean (value, mdns_mdns_provider_get_is_published (self));
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		break;
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		case MDNS_MDNS_PROVIDER_NAME_PROPERTY:
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		g_value_set_string (value, mdns_mdns_provider_get_name (self));
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		break;
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		case MDNS_MDNS_PROVIDER_IS_IPV6_PROPERTY:
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		g_value_set_boolean (value, mdns_mdns_provider_get_is_ipv6 (self));
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		break;
#line 1450 "mdns.c"
		default:
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		break;
#line 1456 "mdns.c"
	}
}


static void
_vala_mdns_mdns_provider_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	MdnsMdnsProvider * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MDNS_TYPE_MDNS_PROVIDER, MdnsMdnsProvider);
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
	switch (property_id) {
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		case MDNS_MDNS_PROVIDER_PORT_PROPERTY:
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		mdns_mdns_provider_set_port (self, g_value_get_uint (value));
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		break;
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		case MDNS_MDNS_PROVIDER_SERVICE_TYPE_PROPERTY:
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		mdns_mdns_provider_set_service_type (self, g_value_get_string (value));
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		break;
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		case MDNS_MDNS_PROVIDER_TXT_PROPERTY:
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		mdns_mdns_provider_set_txt (self, g_value_get_string (value));
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		break;
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		case MDNS_MDNS_PROVIDER_IS_PUBLISHED_PROPERTY:
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		mdns_mdns_provider_set_is_published (self, g_value_get_boolean (value));
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		break;
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		case MDNS_MDNS_PROVIDER_NAME_PROPERTY:
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		mdns_mdns_provider_set_name (self, g_value_get_string (value));
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		break;
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		case MDNS_MDNS_PROVIDER_IS_IPV6_PROPERTY:
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		mdns_mdns_provider_set_is_ipv6 (self, g_value_get_boolean (value));
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		break;
#line 1507 "mdns.c"
		default:
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "/builddir/build/BUILD/presence-0.4.8/src/mdns.vala"
		break;
#line 1513 "mdns.c"
	}
}



